;DATA
  .equ disp_buf, 030h      ; 4 bytes buffer


;;;  reset vector
  .org  0
  dis   i      ; disable interrupts
  jmp  main

;;;  external interrupt vector--trap
  .org  3
here:
  jmp  here      ; nop

;;;  timer interrupt vector
  .org  7
  sel   rb1
  mov a,#0d5h
  mov t,a
  mov  a,#00FH
  orld  p5,a

  mov  a,disp_buf-1
  add  a,r5
  mov  r0,a
  mov   a,@r0

  outl   p1,a

  mov  a,r4
  movd  p5,a
  rl  a
  mov  r4,a

  djnz  r5,exit_tmr
  mov  r4,#0feh
  mov  r5,4

exit_tmr:
  sel   rb0
  mov a,#0d8h
  mov t,a
;  strt   t
  retr

;MAIN
main:
  ;initialize

  dis   tcnti      ; turn off counter

  mov r1,#0
  mov r5,#0
  call copy_buf

  sel   rb1      ; timer variables
  mov  r4,#0feh  ; 1110h - CT position
  mov  r5,4      ; R5 = buf offset
  sel  rb0

  mov   a,#0e5h
  mov   t,a
  strt   t
  en  tcnti

  mov a,#0ffh
  movd  p6,a
main_loop:

  call   onesec
  mov a,r5
  xrl a,#4
  mov r5,a
  mov r1,a
  call copy_buf
  jmp main_loop

msg_table:
  .db #0c0h    ;O
  .db #0c7h    ;L
  .db #086h    ;E
  .db #089h    ;H

  .db #0a4h    ;4   #099h
  .db #0a4h    ;1   #0f9h
  .db #0c0h    ;0
  .db #0a4h    ;2

;;;;;;;;
delay100:
   mov r6,#84
loopex:
   mov r2,#236
loopin:
   djnz r2,loopin
   djnz r6,loopex
   mov r6,#4
loopad:
   djnz r6,loopad
   ret

;;;;;;;;
onesec:
  mov r3,#10
loop_d:
  call delay100
  djnz r3,loop_d
  ret

;;;;;;;;
; copy from msg_table to display buffer 4 bytes
; R1 = msg_table offset
;;;;;;;;
copy_buf:
  mov r0,disp_buf
  mov r2,4
copy_lp:
  mov a,r1
  add a,#msg_table
  movp a,@a
  mov @r0,a
  inc r0
  inc r1
  djnz r2,copy_lp
  ret

